/*
 * Stress Apron Code
 * A Super Simple Galvanic Skin Response Sensor Garment
 *
 * When I am aroused, the lights begin to fade as a calming
 * mechanism. If I am not, the lights remain constant.
 *
 * Done with the aid of Chris Kairalla's documentation 
 * here: http://www.chris3000.com/archive/galvanic-skin-response/
 * Basically acts as a variable resistor to measure skin conductance.
 * 
 * Fade without delay() taken from Christian Liljedahl (this has saved
 * me many times!):
 * http://arduino.cc/forum/index.php/topic,12004.msg91555.html#msg91555
 * See reply #6 to the post
 *
 * See more on the construction of the apron here:
 * 
 * Liza Stark
 * Feb 2014
 * 
 */


int sensorPin = 11;    // Select the input pin for the sensor
int ledArray[4] = {3,6,9,10}; // The 5th LED is connected in parallel to pin 3
                              // Pin 3 is the SCL pin
int sensorValue = 0;  // Variable to store the value coming from the sensor
int newSensorValue; // Variable to 

float myStressThreshold = 130; // Change this number depending your baseline stresslevel
                               // Finding this may require a few deep breathes or thinking
                               // about a grad school final critique.

int value;
long time = 0;
int periode = 3000; //period of the fade
int displace = 100;

void setup() {
  // declare the LESs as OUTPUT:
 for(int i = 0; i < 5; i++){
  pinMode(ledArray[i], OUTPUT);
 
 }
  Serial.begin(9600);
}

void loop() {
  // read the value from the sensor:
  sensorValue = analogRead(sensorPin);    
  //Serial.println(sensorValue);
  // turn the LEDs on
  newSensorValue = map(sensorValue, 0,800,0,200);

  Serial.println(newSensorValue);  

  if(newSensorValue <= myStressThreshold){ 
    for(int j = 0; j < 5; j++){
    digitalWrite(ledArray[j], HIGH); 
    }
  }

  if(newSensorValue > myStressThreshold){
    time = millis();
    value = 128+127*cos(2*PI/periode*time);
    for(int k = 0; k < 5; k++){
    analogWrite(ledArray[k], value);   
    }
  }
}





